> ## Documentation Index
> Fetch the complete documentation index at: https://hoopdev-docs-improve-idp-sso-pages.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Session Reports

> The report payload groups sessions by info types and by a custom field (`group_by`) provided by the client.
The items returns data containing the sum of redact fields performed by a given info type aggregated by the `group_by` attribute.



## OpenAPI

````yaml https://use.hoop.dev/api/openapiv3.json get /reports/sessions
openapi: 3.0.3
info:
  contact:
    email: help@hoop.dev
    name: Help
    url: https://help.hoop.dev
  description: >-
    Hoop.dev is an access gateway for databases and servers with an API for
    packet manipulation
  license:
    name: MIT
    url: https://opensource.org/license/mit
  termsOfService: https://hoop.dev/docs/legal/tos
  title: Hoop Api
  version: 1.49.10
servers:
  - url: https://use.hoop.dev/api
security: []
tags:
  - description: >
      Hoop implements Oauth2 and OIDC protocol to authenticate users in the
      system. To obtain a valid access token users need to authenticate in their
      own identity provider which is generated as a JSON response to the
      endpoint `http(s)://use.hoop.dev/api/login`. The identity provider them
      redirects the user to the callback endpoint containing the access token.


      The recommended approach of obtaining an access token is by visiting the
      Webapp main's page or using the **Hoop command line**. Example:


      ```sh

      hoop config create --api-url https://use.hoop.dev

      # save the token after authenticating at $HOME/.hoop/config.toml

      hoop login

      # show token information

      hoop config view --raw

      ```


      With an access token you could use any HTTP client to interact with the
      documented endpoints.

      The token must be sent through the `Authorization` header.


      Example:


      ```sh

      # obtain the current configuration of the server

      curl https://use.hoop.dev/api/serverinfo -H "Authorization: Bearer
      $ACCESS_TOKEN"

      ```
    name: Authentication
  - description: >
      Users are active and assigned to the default organization when they
      signup. A user could be set to an inactive state preventing it from
      accessing the platform, however it’s recommended to manage the state of
      users in the identity provider.


      - The `sub` claim is used as the main identifier of the user in the
      platform.

      - The profile of the user is derived from the id_token claims `email` and
      `name`.


      When a user authenticates for the first time, it performs an automatic
      signup that persist the profile claims along with it’s unique identifier.

      ​

      ### Groups


      Groups allows defining who may access or interact with certain resources.


      - For connection resources it’s possible to define which groups has access
      to a specific connection, this is enforced when the Access Control feature
      is enabled.

      - For review resources, it’s possible to define which groups are allowed
      to approve an execution, this is enforced when the Review feature is
      enabled.


      > This resource could be managed manually via Webapp or propagated by the
      identity provider via ID Token. In this mode, groups are sync when a user
      performs a login.


      ### Roles


      - The `admin` group is a special role that grants full access to all
      resources


      This role should be granted to users that are responsible for managing the
      Gateway. All other users are regular, meaning that they can access their
      own resources and interact with connections.
    name: User Management
  - description: Routes used to manage and obtain information about the runtime server.
    name: Server Management
  - description: Features available in the gateway. See also **Plugin** resources.
    name: Features
  - description: >-
      Proxy manager endpoints controls how clients connect via gRPC in the
      gateway. These endpoints are meant to be used when a client is initialized
      via `hoop proxy-manager`.
    name: Proxy Manager
  - name: Connections
  - name: Agents
  - name: Runbooks
  - name: Guard Rails
  - name: Reviews
  - name: Sessions
  - name: Organization Management
  - name: Reports
paths:
  /reports/sessions:
    get:
      tags:
        - Reports
      summary: Session Reports
      description: >-
        The report payload groups sessions by info types and by a custom field
        (`group_by`) provided by the client.

        The items returns data containing the sum of redact fields performed by
        a given info type aggregated by the `group_by` attribute.
      parameters:
        - description: Filter by the connection name
          in: query
          name: connection_name
          schema:
            type: string
        - description: End Date, default to current date + 1 day
          in: query
          name: end_date
          schema:
            format: date
            type: string
        - description: Group by this field
          in: query
          name: group_by
          schema:
            default: connection
            enum:
              - connection
              - connection_type
              - id
              - user_email
            type: string
        - description: Filter the report by the ID of the session
          in: query
          name: id
          schema:
            type: string
        - description: Start Date, default to current date
          in: query
          name: start_date
          schema:
            format: date
            type: string
        - description: Filter the report by e-mail
          in: query
          name: user_email
          schema:
            type: string
        - description: Filter the report by the type of the verb
          in: query
          name: verb
          schema:
            enum:
              - exec
              - connect
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.SessionReport'
          description: OK
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Bad Request
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Internal Server Error
components:
  schemas:
    openapi.SessionReport:
      properties:
        items:
          items:
            $ref: '#/components/schemas/openapi.SessionReportItem'
          type: array
        total_redact_count:
          description: The sum of `items[].redact_total`
          example: 12
          type: integer
        total_transformed_bytes:
          description: The sum of `items[].transformed_bytes`
          example: 40293
          type: integer
      type: object
    openapi.HTTPError:
      properties:
        message:
          example: the error description
          type: string
      type: object
    openapi.SessionReportItem:
      properties:
        info_type:
          description: The info type name
          example: EMAIL_ADDRESS
          type: string
        redact_total:
          description: >-
            The total redacts in which this info type was found for this
            resource
          example: 23
          type: integer
        resource:
          description: >-
            The value of the group_by resource (connection, session id, email or
            connection type)
          example: connection
          type: string
        transformed_bytes:
          description: The total transformed bytes performed by this info type
          example: 30012
          type: integer
      type: object

````